// THIS FILE IS AUTO-GENERATED FROM navigator_test.js
// DO NOT EDIT.

package ui

import "time"

import "perkeep.org/pkg/fileembed"

func init() {
	Files.Add("navigator_test.js", 4739, time.Unix(0, 1526085226536968992), fileembed.String(fileembed.JoinStrings("/*\n"+
		"Copyright 2014 The Perkeep Authors\n"+
		"\n"+
		"Licensed under the Apache License, Version 2.0 (the \"License\");\n"+
		"you may not use this file except in compliance with the License.\n"+
		"You may obtain a copy of the License at\n"+
		"\n"+
		"     http://www.apache.org/licenses/LICENSE-2.0\n"+
		"\n"+
		"Unless required by applicable law or agreed to in writing, software\n"+
		"distributed under the License is distributed on an \"AS IS\" BASIS,\n"+
		"WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"+
		"See the License for the specific language governing permissions and\n"+
		"limitations under the License.\n"+
		"*/\n"+
		"\n"+
		"goog.require('goog.Uri');\n"+
		"goog.require('goog.events.EventTarget');\n"+
		"var assert = require('assert');\n"+
		"\n"+
		"goog.require('cam.Navigator');\n"+
		"\n"+
		"var MockLocation = function() {\n"+
		"	goog.base(this);\n"+
		"	this.href = '';\n"+
		"	this.reloadCount = 0;\n"+
		"};\n"+
		"goog.inherits(MockLocation, goog.events.EventTarget);\n"+
		"MockLocation.prototype.reload = function() {\n"+
		"	this.reloadCount++;\n"+
		"};\n"+
		"\n"+
		"var MockHistory = function() {\n"+
		"	this.states = [null];\n"+
		"};\n"+
		"MockHistory.prototype.pushState = function(a, b, url) {\n"+
		"	this.states.push({state:a, url:url});\n"+
		"};\n"+
		"MockHistory.prototype.replaceState = function(a, b, url) {\n"+
		"	this.states[this.states.length - 1] = {state:a, url:url};\n"+
		"}\n"+
		"\n"+
		"var Handler = function() {\n"+
		"	this.lastURL = null;\n"+
		"	this.returnsTrue = false;\n"+
		"	this.handle = this.handle.bind(this);\n"+
		"};\n"+
		"Handler.prototype.handle = function(url) {\n"+
		"	this.lastURL = url;\n"+
		"	return this.returnsTrue;\n",
		"};\n"+
			"\n"+
			"describe('cam.Navigator', function() {\n"+
			"	var mockWindow, mockLocation, mockHistory, handler, navigator;\n"+
			"	var url = new goog.Uri('http://www.camlistore.org/foobar');\n"+
			"\n"+
			"	beforeEach(function() {\n"+
			"		mockWindow = new goog.events.EventTarget();\n"+
			"		mockLocation = new MockLocation();\n"+
			"		mockHistory = new MockHistory();\n"+
			"		handler = new Handler();\n"+
			"		navigator = new cam.Navigator(mockWindow, mockLocation, mockHistory);\n"+
			"		navigator.onWillNavigate = handler.handle;\n"+
			"	});\n"+
			"\n"+
			"	it ('#constructor - seed initial state', function() {\n"+
			"		assert.deepEqual(mockHistory.states, [{state:{}, url:''}]);\n"+
			"	});\n"+
			"\n"+
			"	it('#navigate - no handler', function() {\n"+
			"		// We should do network navigation.\n"+
			"		navigator.onWillNavigate = function(){};\n"+
			"		var handledLocally = navigator.navigate(url);\n"+
			"		assert.equal(mockLocation.href, url.toString());\n"+
			"		assert.equal(mockHistory.states.length, 1);\n"+
			"		assert.equal(handledLocally, false);\n"+
			"	});\n"+
			"\n"+
			"	it('#navigate - handler returns false', function() {\n"+
			"		// Both handlers should get called, we should do network navigation.\n"+
			"		var handledLocally = navigator.navigate(url);\n"+
			"		assert.equal(handler.lastURL, url);\n"+
			"		assert.equal(mockLocation.href, url.toString());\n"+
			"		assert.equal(mockHistory.states.length, 1);\n"+
			"		assert.equal(handledLocally, false);\n"+
			"	});\n"+
			"\n"+
			"	it('#navigate - handler returns true', function() {\n"+
			"		// Both handlers should get called, we should do pushState() navigation.\n"+
			"		handler.returnsTrue = true;\n"+
			"		var handledLocally = navigator.navigate(url);\n"+
			"		assert.equal(handler.lastURL, url);\n"+
			"		assert.equal(mockLocation.href, '');\n"+
			"		assert.deepEqual(mockHistory.states, [{state:{}, url:''}, {state:{}, url:url.to"+
			"String()}]);\n"+
			"		assert.equal(handledLocally, true);\n"+
			"	});\n"+
			"\n"+
			"	it('#handleClick_ - handled', function() {\n"+
			"		handler.returnsTrue = true;\n",
		"		var ev = new goog.events.Event('click');\n"+
			"		ev.button = 0;\n"+
			"		ev.target = {\n"+
			"			nodeName: 'A',\n"+
			"			href: url.toString()\n"+
			"		};\n"+
			"		mockWindow.dispatchEvent(ev);\n"+
			"		assert.equal(mockLocation.href, '');\n"+
			"		assert.deepEqual(mockHistory.states, [{state:{}, url:''}, {state:{}, url:url.to"+
			"String()}]);\n"+
			"	});\n"+
			"\n"+
			"	it('#handleClick_ - not handled', function() {\n"+
			"		var ev = new goog.events.Event('click');\n"+
			"		ev.button = 0;\n"+
			"		ev.target = {\n"+
			"			nodeName: 'A',\n"+
			"			href: url.toString()\n"+
			"		};\n"+
			"		mockWindow.dispatchEvent(ev);\n"+
			"		assert.equal(mockLocation.href, '');\n"+
			"		assert.deepEqual(mockHistory.states, [{state:{}, url:''}]);\n"+
			"		assert.equal(ev.defaultPrevented, false);\n"+
			"	});\n"+
			"\n"+
			"	it('#handlePopState_ - handled', function() {\n"+
			"		handler.returnsTrue = true;\n"+
			"		mockWindow.dispatchEvent({type:'popstate', state:{}});\n"+
			"		assert.equal(mockLocation.reloadCount, 0);\n"+
			"		assert.deepEqual(mockHistory.states, [{state:{}, url:''}]);\n"+
			"	});\n"+
			"\n"+
			"	it('#handlePopState_ - not handled', function() {\n"+
			"		mockWindow.dispatchEvent({type:'popstate', state:{}});\n"+
			"		assert.equal(mockLocation.reloadCount, 1);\n"+
			"		assert.deepEqual(mockHistory.states, [{state:{}, url:''}]);\n"+
			"	});\n"+
			"\n"+
			"	it('#handlePopState_ - ignore initial popstate', function() {\n"+
			"		// Fire a popstate with no state property. This simulates what happens in buggy"+
			" browsers onload. This one should be ignored.\n"+
			"		mockWindow.dispatchEvent({type:'popstate', state:null});\n"+
			"		assert.equal(mockLocation.reloadCount, 0);\n"+
			"\n"+
			"		// Now fire a popstate with a state property it should be handled.\n"+
			"		mockWindow.dispatchEvent({type:'popstate', state:{}});\n"+
			"		assert.equal(mockLocation.reloadCount, 1);\n"+
			"	});\n"+
			"});\n"+
			"")))
}
