// THIS FILE IS AUTO-GENERATED FROM search_session.js
// DO NOT EDIT.

package ui

import "time"

import "perkeep.org/pkg/fileembed"

func init() {
	Files.Add("search_session.js", 10341, time.Unix(0, 1526085226544968992), fileembed.String(fileembed.JoinStrings("/*\n"+
		"Copyright 2013 The Perkeep Authors\n"+
		"\n"+
		"Licensed under the Apache License, Version 2.0 (the \"License\");\n"+
		"you may not use this file except in compliance with the License.\n"+
		"You may obtain a copy of the License at\n"+
		"\n"+
		"	http://www.apache.org/licenses/LICENSE-2.0\n"+
		"\n"+
		"Unless required by applicable law or agreed to in writing, software\n"+
		"distributed under the License is distributed on an \"AS IS\" BASIS,\n"+
		"WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"+
		"See the License for the specific language governing permissions and\n"+
		"limitations under the License.\n"+
		"*/\n"+
		"\n"+
		"goog.provide('cam.SearchSession');\n"+
		"\n"+
		"goog.require('goog.events.EventTarget');\n"+
		"goog.require('goog.Uri');\n"+
		"goog.require('goog.Uri.QueryData');\n"+
		"goog.require('goog.uri.utils');\n"+
		"\n"+
		"goog.require('cam.ServerConnection');\n"+
		"\n"+
		"// A search session is a standing query that notifies you when results change. It"+
		" caches previous results and handles merging new data as it is received. It does "+
		"not tell you _what_ changed; clients must reconcile as they see fit.\n"+
		"//\n"+
		"// TODO(aa): Only deltas should be sent from server to client\n"+
		"// TODO(aa): Need some way to avoid the duplicate query when websocket starts. Id"+
		"eas:\n"+
		"// - Initial XHR query can also specify tag. This tag times out if not used rapid"+
		"ly. Send this same tag in socket query.\n"+
		"// - Socket assumes that client already has first batch of results (slightly race"+
		"y though)\n"+
		"// - Prefer to use socket on client-side, test whether it works and fall back to "+
		"XHR if not.\n"+
		"cam.SearchSession = function(connection, currentUri, query, opt_aroundBlobref, op"+
		"t_sort) {\n"+
		"	goog.base(this);\n"+
		"\n"+
		"	this.connection_ = connection;\n"+
		"	this.currentUri_ = currentUri;\n"+
		"	this.initSocketUri_(currentUri);\n"+
		"	this.hasSocketError_ = false;\n"+
		"	this.query_ = query;\n"+
		"	this.around_ = opt_aroundBlobref;\n"+
		"	this.sort_ = opt_sort || \"-created\";\n"+
		"	this.tag_ = 'q' + (this.constructor.instanceCount_++);\n",
		"	this.continuation_ = this.getContinuation_(this.constructor.SEARCH_SESSION_CHANG"+
			"E_TYPE.NEW);\n"+
			"	this.socket_ = null;\n"+
			"	this.supportsWebSocket_ = false;\n"+
			"	this.isComplete_ = false;\n"+
			"\n"+
			"	this.resetData_();\n"+
			"};\n"+
			"goog.inherits(cam.SearchSession, goog.events.EventTarget);\n"+
			"\n"+
			"// We fire this event when the data changes in any way.\n"+
			"cam.SearchSession.SEARCH_SESSION_CHANGED = 'search-session-change';\n"+
			"\n"+
			"// We fire this event when the search session receives general server status data"+
			".\n"+
			"cam.SearchSession.SEARCH_SESSION_STATUS = 'search-session-status';\n"+
			"\n"+
			"// We fire this event when the search session encounters an error.\n"+
			"cam.SearchSession.SEARCH_SESSION_ERROR = 'search-session-error';\n"+
			"\n"+
			"// TODO(aa): This is only used by BlobItemContainer. Once we switch over to BlobI"+
			"temContainerReact completely, it can be removed.\n"+
			"cam.SearchSession.SEARCH_SESSION_CHANGE_TYPE = {\n"+
			"	NEW: 1,\n"+
			"	APPEND: 2,\n"+
			"	UPDATE: 3\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.PAGE_SIZE_ = 50;\n"+
			"\n"+
			"cam.SearchSession.instanceCount_ = 0;\n"+
			"\n"+
			"cam.SearchSession.prototype.getQuery = function() {\n"+
			"	return this.query_;\n"+
			"};\n"+
			"\n"+
			"// getQueryExprOrRef returns the query if is a string (i.e. a search\n"+
			"// expression). Otherwise it returns the empty string.\n"+
			"cam.SearchSession.prototype.getQueryExprOrRef = function() {\n"+
			"	var q = this.query_;\n"+
			"	if (!q) {\n"+
			"		return '';\n"+
			"	}\n"+
			"	if (typeof q === 'string') {\n"+
			"		return q.trim();\n"+
			"	}\n"+
			"	// if it is an object (ugh!) return the blobRefPrefix if it exists\n"+
			"	if (!q.blobRefPrefix) {\n"+
			"		return '';\n"+
			"	}\n",
		"	return 'ref:'+q.blobRefPrefix;\n"+
			"};\n"+
			"\n"+
			"// stripMapZoom allows us to \"hide\" the map aspect zoom from when the search\n"+
			"// session sends a query to the server. We want to keep this.query_ intact (with\n"+
			"// the map zoom) though, because the map aspect relies on this.query_ as a\n"+
			"// bootstrap. This is a terrible hack that should eventually go.\n"+
			"cam.SearchSession.prototype.stripMapZoom = function(q) {\n"+
			"	if (!q) {\n"+
			"		return null;\n"+
			"	}\n"+
			"	if (typeof q === 'string') {\n"+
			"		return goreact.DeleteMapZoom(q);\n"+
			"	}\n"+
			"	return q;\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.isEmptyQuery = function() {\n"+
			"	var q = this.query_;\n"+
			"	if (!q) {\n"+
			"		return true;\n"+
			"	}\n"+
			"	if (typeof q === 'string') {\n"+
			"		if (q.trim() == \"\") {\n"+
			"			return true;\n"+
			"		}\n"+
			"	}\n"+
			"	return false;\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.getAround = function() {\n"+
			"	return this.around_;\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.getSort = function() {\n"+
			"	return this.sort_;\n"+
			"};\n"+
			"\n"+
			"// Returns all the data we currently have loaded.\n"+
			"// It is guaranteed to return the following properties:\n"+
			"// blobs // non-null\n"+
			"// description\n"+
			"// description.meta\n"+
			"cam.SearchSession.prototype.getCurrentResults = function() {\n"+
			"	return this.data_;\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.hasSocketError = function() {\n"+
			"	return this.hasSocketError_;\n"+
			"};\n",
		"\n"+
			"// Loads the next page of data. This is safe to call while a load is in progress;"+
			" multiple calls for the same page will be collapsed. The SEARCH_SESSION_CHANGED e"+
			"vent will be dispatched when the new data is available.\n"+
			"cam.SearchSession.prototype.loadMoreResults = function() {\n"+
			"	if (!this.continuation_) {\n"+
			"		return;\n"+
			"	}\n"+
			"\n"+
			"	var c = this.continuation_;\n"+
			"	this.continuation_ = null;\n"+
			"	c();\n"+
			"};\n"+
			"\n"+
			"// Returns true if it is known that all data which can be loaded for this query h"+
			"as been.\n"+
			"cam.SearchSession.prototype.isComplete = function() {\n"+
			"	return this.isComplete_;\n"+
			"}\n"+
			"\n"+
			"cam.SearchSession.prototype.supportsChangeNotifications = function() {\n"+
			"	return this.supportsWebSocket_;\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.refreshIfNecessary = function() {\n"+
			"	if (this.supportsWebSocket_) {\n"+
			"		return;\n"+
			"	}\n"+
			"\n"+
			"	this.continuation_ = this.getContinuation_(this.constructor.SEARCH_SESSION_CHANG"+
			"E_TYPE.UPDATE, {\n"+
			"		limit: Math.max(this.data_.blobs.length, this.constructor.PAGE_SIZE_),\n"+
			"	});\n"+
			"	this.resetData_();\n"+
			"	this.loadMoreResults();\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.close = function() {\n"+
			"	if (this.socket_) {\n"+
			"		this.socket_.onerror = null;\n"+
			"		this.socket_.onclose = null;\n"+
			"		this.socket_.close();\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.getMeta = function(blobref) {\n"+
			"	return this.data_.description.meta[blobref];\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.getResolvedMeta = function(blobref) {\n",
		"	var meta = this.data_.description.meta[blobref];\n"+
			"	if (meta && meta.camliType == 'permanode') {\n"+
			"		var camliContent = cam.permanodeUtils.getSingleAttr(meta.permanode, 'camliConte"+
			"nt');\n"+
			"		if (camliContent) {\n"+
			"			return this.data_.description.meta[camliContent];\n"+
			"		}\n"+
			"	}\n"+
			"	return meta;\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.getTitle = function(blobref) {\n"+
			"	var meta = this.getMeta(blobref);\n"+
			"	if (meta.camliType == 'permanode') {\n"+
			"		var title = cam.permanodeUtils.getSingleAttr(meta.permanode, 'title');\n"+
			"		if (title) {\n"+
			"			return title;\n"+
			"		}\n"+
			"	}\n"+
			"	var rm = this.getResolvedMeta(blobref);\n"+
			"	return (rm && rm.camliType == 'file' && rm.file.fileName) || (rm && rm.camliType"+
			" == 'directory' && rm.dir.fileName) || '';\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.resetData_ = function() {\n"+
			"	this.data_ = {\n"+
			"		blobs: [],\n"+
			"		description: {\n"+
			"			meta: {}\n"+
			"		}\n"+
			"	};\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.initSocketUri_ = function(currentUri) {\n"+
			"	if (!goog.global.WebSocket) {\n"+
			"		return;\n"+
			"	}\n"+
			"\n"+
			"	this.socketUri_ = currentUri;\n"+
			"	this.socketUri_.setFragment('');\n"+
			"	var config = this.connection_.getConfig();\n"+
			"	this.socketUri_.setPath(goog.uri.utils.appendPath(config.searchRoot, 'camli/sear"+
			"ch/ws'));\n"+
			"	this.socketUri_.setQuery(goog.Uri.QueryData.createFromMap({authtoken: config.aut"+
			"hToken || ''}));\n"+
			"	if (this.socketUri_.getScheme() == \"https\") {\n"+
			"		this.socketUri_.setScheme(\"wss\");\n"+
			"	} else {\n"+
			"		this.socketUri_.setScheme(\"ws\");\n"+
			"	}\n",
		"};\n"+
			"\n"+
			"cam.SearchSession.prototype.getContinuation_ = function(changeType, opts) {\n"+
			"	if (!opts) {\n"+
			"		opts = {};\n"+
			"	}\n"+
			"	if (!opts.limit) {\n"+
			"		opts.limit = this.constructor.PAGE_SIZE_;\n"+
			"	}\n"+
			"	if (!opts.sort) {\n"+
			"		opts.sort = this.sort_;\n"+
			"	}\n"+
			"	opts.describe = cam.ServerConnection.DESCRIBE_REQUEST;\n"+
			"\n"+
			"	return this.connection_.search.bind(this.connection_, this.stripMapZoom(this.que"+
			"ry_), opts,\n"+
			"		this.searchDone_.bind(this, changeType));\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.searchDone_ = function(changeType, result) {\n"+
			"	if (!result) {\n"+
			"		result = {};\n"+
			"	}\n"+
			"	if (!result.blobs) {\n"+
			"		result.blobs = [];\n"+
			"	}\n"+
			"	if (!result.description) {\n"+
			"		result.description = {};\n"+
			"	}\n"+
			"\n"+
			"	var changes = false;\n"+
			"\n"+
			"	if (changeType == this.constructor.SEARCH_SESSION_CHANGE_TYPE.APPEND) {\n"+
			"		changes = Boolean(result.blobs.length);\n"+
			"		this.data_.blobs = this.data_.blobs.concat(result.blobs);\n"+
			"		goog.mixin(this.data_.description.meta, result.description.meta);\n"+
			"	} else {\n"+
			"		changes = true;\n"+
			"		this.data_.blobs = result.blobs;\n"+
			"		this.data_.description = result.description;\n"+
			"	}\n"+
			"\n"+
			"	if (result.continue) {\n"+
			"		this.continuation_ = this.getContinuation_(this.constructor.SEARCH_SESSION_CHAN"+
			"GE_TYPE.APPEND, {\n"+
			"			continuationToken: result.continue,\n"+
			"		});\n"+
			"	} else {\n"+
			"		this.continuation_ = null;\n"+
			"		this.isComplete_ = true;\n",
		"	}\n"+
			"\n"+
			"	if (changes) {\n"+
			"		this.dispatchEvent({type: this.constructor.SEARCH_SESSION_CHANGED, changeType: "+
			"changeType});\n"+
			"\n"+
			"		if (changeType == this.constructor.SEARCH_SESSION_CHANGE_TYPE.NEW || changeType"+
			" == this.constructor.SEARCH_SESSION_CHANGE_TYPE.APPEND) {\n"+
			"			this.startSocketQuery_();\n"+
			"		}\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.handleError_ = function(message) {\n"+
			"	this.hasSocketError_ = true;\n"+
			"	this.dispatchEvent({type: this.constructor.SEARCH_SESSION_ERROR});\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.handleStatus_ = function(data) {\n"+
			"	if (data.tag == '_status') {\n"+
			"		this.dispatchEvent({\n"+
			"			type: this.constructor.SEARCH_SESSION_STATUS,\n"+
			"			status: data.status,\n"+
			"		});\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"cam.SearchSession.prototype.startSocketQuery_ = function() {\n"+
			"	if (!this.socketUri_) {\n"+
			"		return;\n"+
			"	}\n"+
			"\n"+
			"	this.close();\n"+
			"\n"+
			"	var numResults = 0;\n"+
			"	if (this.data_ && this.data_.blobs) {\n"+
			"		numResults = this.data_.blobs.length;\n"+
			"	}\n"+
			"	var queryOpts = {\n"+
			"		describe: cam.ServerConnection.DESCRIBE_REQUEST,\n"+
			"		limit: Math.max(numResults, this.constructor.PAGE_SIZE_),\n"+
			"		around: this.around_,\n"+
			"		sort: this.sort_,\n"+
			"	};\n"+
			"	var query = this.connection_.buildQuery(this.stripMapZoom(this.query_), queryOpt"+
			"s);\n"+
			"\n"+
			"	this.socket_ = new WebSocket(this.socketUri_.toString());\n"+
			"	this.socket_.onopen = function() {\n"+
			"		var message = {\n",
		"			tag: this.tag_,\n"+
			"			query: query\n"+
			"		};\n"+
			"		this.socket_.send(JSON.stringify(message));\n"+
			"	}.bind(this);\n"+
			"	this.socket_.onclose =\n"+
			"	this.socket_.onerror = function(e) {\n"+
			"		this.handleError_('WebSocket error - click to reload');\n"+
			"	}.bind(this);\n"+
			"	this.socket_.onmessage = function(e) {\n"+
			"		this.supportsWebSocket_ = true;\n"+
			"		this.handleStatus_(JSON.parse(e.data));\n"+
			"		// Ignore the first response.\n"+
			"		this.socket_.onmessage = function(e) {\n"+
			"			var result = JSON.parse(e.data);\n"+
			"			this.handleStatus_(result);\n"+
			"			if (result.tag == this.tag_) {\n"+
			"				this.searchDone_(this.constructor.SEARCH_SESSION_CHANGE_TYPE.UPDATE, result.r"+
			"esult);\n"+
			"			}\n"+
			"		}.bind(this);\n"+
			"	}.bind(this);\n"+
			"};\n"+
			"")))
}
